/*
 This source file is part of the Swift.org open source project

 Copyright (c) 2021 Apple Inc. and the Swift project authors
 Licensed under Apache License v2.0 with Runtime Library Exception

 See https://swift.org/LICENSE.txt for license information
 See https://swift.org/CONTRIBUTORS.txt for Swift project authors
*/

import Markdown

/**
 A textual replacement.
 */
public struct Replacement {
    /// The range to replace.
    public var range: SourceRange
    
    /// The replacement text.
    public var replacement: String
    
    public init(range: SourceRange, replacement: String) {
        self.range = range
        self.replacement = replacement
    }
}
